// File algo_pc1.h
// written in Borland Turbo C 2.0 on PC
// PC1 Cipher Algorithm ( Pukall Cipher 1 )
// By Alexander PUKALL 1991
// free code no restriction to use
// please include the name of the Author in the final software
// the Key is 128 bits
// Tested with Turbo C 2.0 for DOS and Microsoft Visual C++ 5.0 for Win 32

// Note that PC1COD.c is the encryption routine
// PC1DEC.c is the decryption routine
// Only the K zone change in the two routines
// You can create a single routine with the two parts in it

#ifndef ALGOPC1_H
#define ALGOPC1_H

#include "resource.h"

class QWidget;

// internal functions
UINT pc1Code(UINT *x1a2, UINT *i, UINT *x1a0, UINT *si);
void pc1Assemble(UINT *x1a0, const BYTE *key, UINT *inter, UINT *i, UINT *x1a2, UINT *si);

// files functions
int addFileAlgoPc1(QWidget *wWin, const char *szFilename, const BYTE *cPassword, FILE *fFileToAdd, FILE *fArchive, BYTE *cHashControl, QWORD *qwCompressedFileSize, QWORD *qwEncodedFileSize);
int extractFilesAlgoPc1(QWidget *wWin, const char *szFilename, const BYTE *cPassword, FILE *fFileToDecode, FILE *fArchive, BYTE *cHashControl, QWORD qwCompressedFileSize, QWORD qwEncodedFileSize);

// buffer functions (used to encode filenames for example)
int pc1Encode(BYTE *cDestBuffer, const BYTE *cSrcBuffer, DWORD dwBufferLen, const BYTE *cPass);
int pc1Decode(BYTE *cDestBuffer, const BYTE *cSrcBuffer, DWORD dwBufferLen, const BYTE *cPass);

#endif // ALGOPC1_H